export default {
  data() {
    return {
      controllerName: '',
      viewTag: '',
      data: {},
      viewList: [],
      selectedViewList: {},
      orderBy: ''
    };
  },
  watch: {
    orderBy() {
      this.$refs.listWrapper.loadData();
    }
  },
  activated() {
    this.$refs.listWrapper.loadData();
  },
  methods: {
    /** 获取视图列表
     *  默认获取可用的视图(0:所有的视图,1:可用的视图)
     */
    async getViewList() {
      let url = `api/${this.controllerName}/GetViewList?tag=${this.viewTag}`;
      this.viewList = await rt.get(url);

      if (this.viewList.length > 1) {
        this.selectedViewList = this.viewList[1];
      } else if (this.viewList.length > 0) {
        this.selectedViewList = this.viewList[0];
      }
    },
    async fetchData(page) {
      if (this.viewList.length == 0) {
        await this.getViewList();
      }
      let url = `api/${this.controllerName}/GetViewData?viewId=${this.selectedViewList.Id}&quickSearch=${
        this.quickSearch
      }&searchList=${encodeURIComponent(JSON.stringify(this.searchList))}&orderBy=${this.orderBy}&pageSize=${page.pageSize}&pageIndex=${
        page.pageIndex
      }`.replace(/undefined/g, '');
      return rt.get(url).then(resp => resp.DataList);
    },
    delData(Id) {
      const url = `api/${this.controllerName}/DeleteData`;
      rt.confirm('是否删除？').then(() => {
        try {
          rt.post(url, [Id]).then(() => {
            const index = this.$refs.listWrapper.dataList.findIndex(item => item.Id === Id);
            if (index != -1) {
              this.$refs.listWrapper.dataList.splice(index, 1);
            }
          });
        } catch (error) {
          rt.showErrorToast(error.message);
        }
      });
    }
  }
};
