export default {
  data() {
    return {
      Id: typeof this.$route.params.id == 'object' ? this.$route.params.id.Id : this.$route.params.id,
      controllerName: '',
      data: {},
      attachmentList: []
    };
  },
  mounted() {
    this.setHeaderStyle();
  },
  activated() {
    this.loadData();
  },
  methods: {
    async loadData() {
      if (!rt.isNilOrWhiteSpace(this.Id)) {
        this.data = await rt.get(`api/${this.controllerName}/GetData?Id=${this.Id}`);
        this.attachmentList = await this.getAttachmentList();
        this.attachmentList.forEach(item => {
          item.Url = item.downloadUrl;
        });
      }
      if (typeof this.loadComplete === 'function') {
        await this.loadComplete();
      }
    },
    /** 设置标题的样式
     *  需要定义content,header,navbar的ref
     */
    setHeaderStyle() {
      let content = this.$refs.content;
      let header = this.$refs.header;
      let navbar = this.$refs.navbar;
      if (rt.isNil(content) || rt.isNil(header) || rt.isNil(navbar)) {
        return;
      }
      header.$el.classList.add('has-background');
      navbar.$el.classList.add('navbar-background');
      content.$el.addEventListener('scroll', () => {
        if (content.scrollTop < 96) {
          header.$el.classList.add('has-background');
          navbar.$el.classList.add('navbar-background');
          navbar.$el.style.backgroundPosition = `0px ${content.scrollTop / 0.96}%`;
        } else {
          header.$el.classList.remove('has-background');
          navbar.$el.classList.remove('navbar-background');
          navbar.$el.style.backgroundPosition = '';
        }
      });
    },
    getAttachmentList() {
      const url = `api/${this.controllerName}/GetAttachmentList?id=${this.Id}`;
      return rt.get(url);
    },
    delData() {
      const url = `api/${this.controllerName}/DeleteData`;
      rt.confirm('是否删除？').then(() => {
        try {
          rt.post(url, [this.Id]).then(() => {
            this.$router.back();
          });
        } catch (error) {
          rt.showErrorToast(error.message);
        }
      });
    }
  }
};
